<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

if(! isset($_GET["img"]))die();
$file=trim(urldecode($_GET["img"]),"/");

$thumbnailHeight=(isset($_GET["h"]))?$_GET["h"]:100;
$thumbnailWidth=(isset($_GET["w"]))?$_GET["w"]:100;

$cacheThumbnails=false;
$thumbnailCacheSubdir = "thumbs";

$thumbDir = dirname($file)."/".$thumbnailCacheSubdir;
$thumbFile = $thumbDir."/".basename($file);
if ($cacheThumbnails) {
	if (file_exists($thumbDir)) {
		if (!is_dir($thumbDir)) {
			$cacheThumbnails = false;
		}
	} else {
		if (@mkdir($thumbDir)) {
			chmod($thumbDir, "0777");
		} else {
			$cacheThumbnails = false;
		}
	}
	if (file_exists($thumbFile)) {
		if (filemtime($thumbFile)>=filemtime($file)) {
			Header("Location: ".dirname($_SERVER["PHP_SELF"])."/".$thumbFile);
			die();
		}
	}
}
$contentType = "";
$extension = strtolower(substr(strrchr($file, "."), 1));
switch ($extension) {
	case "gif":		$src = imagecreatefromgif($file); $contentType="image/gif"; break;
	case "jpg":		// fall through
	case "jpeg":	$src = imagecreatefromjpeg($file); $contentType="image/jpeg"; break;
	case "png":		$src = imagecreatefrompng($file); $contentType="image/png"; break;
	default:	die(); break;
}
$srcWidth = imagesx($src);
$srcHeight = imagesy($src);
$srcAspectRatio = $srcWidth / $srcHeight;

$maxAge = 3600; // one hour
Header("Cache-Control: public, max-age=$maxAge, must-revalidate");
Header("Expires: ".gmdate("D, d M Y H:i:s", time()+$maxAge)." GMT");

if ($srcHeight<=$thumbnailHeight AND $srcWidth<=$thumbnailWidth) {
	Header("Content-Type: $contentType");
	readfile($file);
} else {
	if ($srcWidth > $srcHeight) {
		$thumbWidth = $thumbnailWidth;
		$thumbHeight = $thumbWidth / $srcAspectRatio;
	} else {
		$thumbHeight = $thumbnailHeight;
		$thumbWidth = $thumbHeight * $srcAspectRatio;
	}
	if (function_exists('imagecreatetruecolor')) {
		$thumb = imagecreatetruecolor($thumbWidth, $thumbHeight);
	} else {
		$thumb = imagecreate($thumbWidth, $thumbHeight);
	} 
	imagecopyresampled($thumb, $src, 0, 0, 0, 0, $thumbWidth, $thumbHeight, $srcWidth, $srcHeight);
	Header("Content-Type: image/jpeg");
	if ($cacheThumbnails) {
		imagejpeg($thumb, $thumbFile,100);
		chmod($thumbFile, "0777");
		readfile($thumbFile);
	} else {
		imagejpeg($thumb,NULL,100);
	}
}
die();
?>