<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class Accordion {
	var $animate; //* @cfg {Boolean} animate global animation flag for all panels. (defaults to true)
	var $boxWrap; //* @cfg {Boolean} boxWrap set to true to wrap wrapEl the body is child of (defaults to false)
	var $draggable; //* @cfg {Boolean} draggable set to false to disallow panels dragging (defaults to true)
	var $fitHeight; //* @cfg {Boolean} fitHeight set to true if you use fixed height dock
	var $id; 
	var $independant; //* @cfg {Boolean} independent true to make panels independent (defaults to false)
	var $initialHeight;	//* @cfg {Integer} initialHeight Initial height to set box to (defaults to 0)
	var $monitorResize;//* @cfg {Boolean} monitorWindowResize if true panels are moved to viewport if window is small (defaults to true)
	var $resize; //* @cfg {Boolean} resizable global resizable flag for all panels (defaults to true)
	var $undockable; //* @cfg {Boolean} undockable true to allow undocking of panels (defaults to true)
	var $useShadow; //* @cfg {Boolean} useShadow global useShadow flag for all panels. (defaults to true)
	var $panels; //* @cfg {Element/HTMLElement/String} wrapEl Element to wrap with nice surrounding
	
	function Accordion(
											$id,
											$animate = true, 
											$boxWrap = false, 
											$draggable = false, 
											$fitHeight = true,
											$independant = false,
											$initialHeight = 0,
											$monitorWindowResize = true,
											$resizable = true,
											$undockable = true,
											$useShadow = true
										)
	{
		$this->animate = $animate;
		$this->boxWrap = $boxWrap;
		$this->draggable = $draggable;
		$this->fitHeight = $fitHeight;
		$this->id = $this->id;
		$this->independant = $independant;
		$this->initialHeight = $initialHeight;
		$this->monitorWindowResize = $monitorWindowResize;
		$this->resizable = $resizable;
		$this->undockable = $undockable;
		$this->useShadow = $useShadow;
	}

	function CreateId()
	{
		srand((double) microtime()*1000000);
		$random_number = rand();
		return 'acc'.$random_number;
	}
	
	function AddPanel($panel)
	{
		if($this->panels == null)
			$this->panels = Array();

		array_push($this->panels, $panel);
	}
	
	function AddPanels($panels)
	{
		if($this->panels == null)
			$this->panels = Array();

		$this->panels = $panels;
	}
	
	function Render()
	{
		global $sLoc;
		$text = '<script type="text/javascript" src="'.$sLoc.'lib/accordion/Ext.ux.Accordion.js"></script>'."\r\n";
		$text .= '<script type="text/javascript" src="'.$sLoc.'lib/accordion/Ext.ux.InfoPanel.js"></script>'."\r\n";
		$text .= '<link rel="stylesheet" type="text/css" href="'.$sLoc.'lib/accordion/accordion.css">'."\r\n";

		$text .= '<div id="'.$this->id.'-ct">
					<div id="'.$this->id.'-wrap">
						<div id="'.$this->id.'-body">';
		
		$count = 0;
		foreach($this->panels as $panel)
		{
			$text .= $panel->RenderHtml($this->id.'panel'.$count);
			$count++;
		}
		
		$text .='	</div>
				</div>
			</div>';

		
		$text.='<script type="text/javascript">'."\n";
		$text.='Ext.onReady(function() {'."\n";
		//create accordion
		if($this->fitHeight)
			$text.='	var '.$this->id.'acc = new Ext.ux.Accordion(\''.$this->id.'-body\', {'."\n";
		else
			$text.='	var '.$this->id.'acc = new Ext.ux.Accordion(\''.$this->id.'-ct\', {'."\n";

		if($this->animate == false)
			$text.='    animate: false,'."\n";
		if($this->boxWrap)
			$text.='		boxWrap: true,'."\n";
		if($this->draggable)
			$text.='    draggable: true,'."\n";
		if($this->fitHeight)
			$text.='		fitHeight: true,'."\n";
		if($this->independant)
			$text.='		independent: true,'."\n";
		if($this->initialHeight > 0)
			$text.='		initialHeight: "'.$this->initialHeight.'",'."\n";
		if($this->monitorWindowResize == false)
			$text.='    monitorWindowResize == false,'."\n";
		if($this->resizable == false)
			$text.='		resizable: false,'."\n";
		if($this->undockable == false)
			$text.='		undockable: false,'."\n";
		if($this->useShadow == false)
			$text.='		useShadow: false,'."\n";		
		$text.='		fitContainer: true,'."\n";
		$text.='		fitToFrame: true,'."\n";
		
		if(strrpos($text, ",") == strlen($text) - 2)
			$text = substr($text, 0, strlen($text) - 2);

		
		$text.=' 	});'."\n";
		
		//$text.='// initialize state manager, we will use cookies';
		$text.='Ext.state.Manager.setProvider(new Ext.state.CookieProvider());'."\n";

		$count = 0;
		foreach($this->panels as $panel)
		{
			$text .= $panel->RenderJs($this->id.'panel'.$count, $this->id.'acc');
			$count++;
		}

		if($this->resize)
		{
			$text.= 'var '.$this->id.'2Ct = Ext.get(\''.$this->id.'-ct\');
			var resizer = new Ext.Resizable('.$this->id.'2Ct, {
				handles:\'s e se\'
				, transparent: true
				, minHeight: 180 //244
				, minWidth: 150 // 224
				, pinned: true
			});
			resizer.on({
				beforeresize: {
					scope:'.$this->id.'acc
					, fn: function(r, e) {
		
						// save old sizes
						r.oldSize = '.$this->id.'2Ct.getSize();
						r.oldAccSize = this.body.getSize();
				}}
				, resize: {
					scope:'.$this->id.'acc
					, fn: function(r, w, h, e) {
		
						// calculate deltas
						var dw, dh;
						dw = w - r.oldSize.width;
						dh = h - r.oldSize.height;
		
						// resize Accordion 
						this.setSize(r.oldAccSize.width + dw, r.oldAccSize.height + dh);
		
				}}
			});';
		}
		$text.=$this->id.'acc.restoreState();'."\n";

		$text.='})'."\n";
		$text.='</script>'."\n";

		return $text;
	}
}

class Panel {
	var $animate; //* @cfg {Boolean} animate false to switch animation of expand/collapse off (defaults to true)
	var $bodyClass;	//* @cfg {String} bodyClass css class added to the body in addition to the default class(es)
	var $collapsed; //* @cfg {Boolean} collapsed false to start with the expanded body (defaults to true)
	var $collapseOnUnPin; //* @cfg {Boolean} collapseOnUnpin unpinned panel is collapsed when possible (defaults to true)	
	var $collapsible; //* @cfg {Boolean} collapsible false to disable collapsibility (defaults to true)
	var $draggable;	//* @cfg {Boolean} draggable true to allow panel dragging (defaults to false)	
	var $duration; //* @cfg {Float} duration Duration of animation in seconds (defaults to 0.35)
	var $easingCollapse; //* @cfg {String} easingCollapse Easing to use for collapse animation (e.g. 'backIn')
	var $easingExpand; //* @cfg {String} easingExpand Easing to use for expand animation (e.g. 'backOut')	
	var $icon; //* @cfg {String} icon Path for icon to display in the title
	var $minWidth; //* @cfg {Integer} minWidth minimal width in pixels of the resizable panel (no default)
	var $maxWidth; //* @cfg {Integer} maxWidth maximal width in pixels of the resizable panel (no default)
	var $minHeight; //* @cfg {Integer} minHeight minimal height in pixels of the resizable panel (no default)
	var $maxHeight; //* @cfg {Integer} maxHeight maximal height in pixels of the resizable panel (no default)
	var $pinned; //* @cfg {Boolean} pinned true to start in pinned state (implies collapsed:false) (defaults to false)
	var $resizable; //* @cfg {Boolean} resizable true to allow use resize width of the panel. 
	var $shadowMode; //* @cfg {String} shadowMode defaults to 'sides'.
	var $showPin; //* @cfg {Boolean} showPin Show the pin button - makes sense only if panel is part of Accordion
	var $trigger; //* @cfg {String} trigger 'title' or 'button'. Click where expands/collapses the panel (defaults to 'title')	
	var $useShadow; //* @cfg {Boolean} useShadow Use shadows for undocked panels or panels w/o dock. (defaults to true)	
	var $title;
	var $content;
	
	function Panel(
									$title = null, 
									$content = null, 
									$animate = true,
									$bodyClass = "",
									$collapsed = true,
									$collapseOnUnPin = true,
									$collapsible = true,
									$draggable = false,
									$duration = '0.35',
									$easingCollapse = "",
									$easingExpand = "",
									$icon = "",
									$minWidth = 0,
									$maxWidth = 0,
									$minHeight = 0,
									$maxHeight = 0,
									$pinned = false,
									$resizable = true,
									$shadowMode = "sides",
									$showPin = true,
									$trigger = "title",
									$useShadow = true
								)
	{
		if(!is_null($title))
			$this->title = $title;
		if(!is_null($content))
			$this->content = $content;
			
		$this->animate = $animate;
		$this->bodyClass = $bodyClass;
		$this->collapsed = $collapsed;
		$this->collapseOnUnPin = $collapseOnUnPin;
		$this->collapsible = $collapsible;
		$this->draggable = $draggable;
		$this->duration = $duration;
		$this->easingCollapse = $easingCollapse;
		$this->easingExpand = $easingExpand;
		$this->icon = $icon;
		$this->minWidth = $minWidth;
		$this->maxWidth = $maxWidth;
		$this->minHeight = $minHeight;
		$this->maxHeight = $maxHeight;
		$this->pinned = $pinned;
		$this->resizable = $resizable;
		$this->shadowMode = $shadowMode;
		$this->showPin = $showPin;
		$this->trigger = $trigger;
		$this->useShadow = $useShadow;
	}

	function RenderHtml($id)
	{
		if($this->title != "" && $this->content != "")
		{
			if(!isset($text))$text="";
			$text.='<div id="'.$id.'">'."\r\n";
			$text.='<div>'.$this->title.'</div>'."\r\n";
      $text.='<div class="text-content">'.$this->content.'</div>'."\r\n";
			$text.='</div>'."\r\n";
			
			return $text;
		}
	}
	
	function RenderJS($id, $accid)
	{
		if(!isset($text))$text="";
		$text.="\n".'var '.$id.' = '.$accid.'.add(new Ext.ux.InfoPanel(\''.$id.'\''."\n";
		$text.=', {'."\n";
		//$text.='  bodyEl: \''.$id.'\','."\n";
		//$text.='  title: \''.$this->title.'\','."\n";
		//$text.='  content: \''.nl2br($this->content).'\','."\n";
		if($this->animate == false)
		if($this->bodyClass != "")
			$text.='  bodyClass: '.$this->bodyClass.','."\n";
		if($this->collapsed == false)
			$text.='  collapsed: false,'."\n";
		if($this->collapseOnUnPin == false)
			$text.='  collapseOnUnPin: false,'."\n";
		if($this->collapsible == false)
			$text.='  collapsible: false,'."\n";
		if($this->draggable)
			$text.='  draggable: true,'."\n";
		$text.='  duration: '.$this->duration.','."\n";
		if($this->easingCollapse != "")
			$text.='  easingCollapse: \''.$this->easingCollapse.'\','."\n";
		if($this->easingExpand != "")
			$text.='  easingExpand: \''.$this->easingExpand.'\','."\n";
		if($this->icon != "")
			$text.='  icon: '.$this->icon.','."\n";
		if($this->minWidth > 0)
			$text.='	minWidth: '.$this->minWidth.','."\n";
		if($this->maxWidth > 0)
			$text.='  maxWidth: '.$this->maxWidth.','."\n";
		if($this->minHeight > 0)
			$text.='  minHeight: '.$this->minHeight.','."\n";
		if($this->maxHeight > 0)
			$text.='  maxHeight: '.$this->maxHeight.','."\n";
		if($this->pinned)
			$text.='  pinned: true,'."\n";
		if($this->resizable == false)
			$text.='  resizable: false,'."\n";
		if($this->shadowMode != "sides")
			$text.='	shadowMode: '.$this->shadowMode.','."\n";
		if($this->showPin == false)
			$text.='	showPin: false,'."\n";
		if($this->trigger != "title")
			$text.='	trigger: '.$this->trigger.','."\n";
		if($this->useShadow == false)
			$text.='  useShadow: false,'."\n";

		if(strrpos($text, ",") == strlen($text) - 2)
			$text = substr($text, 0, strlen($text) - 2);
		$text.='}));'."\n";
		
		return $text;
	}
}
?>