<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* ---------------------------------------
 SEO - title, meta tags
 --------------------------------------- */
function renderMetaTags(){
	global $sMetaDesc,$sMetaKeywords,$sContent,$sTitle,$sPageTitle,$sSiteLanguage,$iKeyType,$bStartpage;

	$_sReturn = "";

	$_sExtra = ($bStartpage==1) ? '' : 'NO';
//	$_sReturn .= '<META NAME="ROBOTS" CONTENT="'.$_sExtra.'INDEX,FOLLOW">'.chr(13);
	$_sReturn .= '<META NAME="ROBOTS" CONTENT="all">'.chr(13);

	// Site language
	$_sql = "SELECT DISTINCT(l.sLanguageCode) FROM tb_extra_languages l INNER JOIN tb_structure s ON s.sLanguage=l.sLanguageAbbr ORDER BY l.iKey";
	$_aLang = getTableColumnsList($_sql);
	if(is_array($_aLang)){
		$_sLang = "";
		for($_i=0;$_i<count($_aLang);$_i++){$_sLang .= $_aLang[$_i]["sLanguageCode"].",";}
		$_sLang = trim($_sLang,",");
		$_sReturn .= '<META HTTP-EQUIV="CONTENT-LANGUAGE" CONTENT="'.$_sLang.'">'.chr(13);
	}

	$_sMetaDesc = "";
	if(trim($sMetaDesc)!=""){
		$_sMetaDesc = $sMetaDesc;
	}

	if(isset($_GET["product"]) && is_numeric($_GET["product"])){
		$_sql = "SELECT sDescShort".strtoupper($sSiteLanguage)." sDescShort,sDescFull".strtoupper($sSiteLanguage)." sDescFull FROM tb_shop_products WHERE iKey=".$_GET["product"];
		$_aProd = getTableColumns($_sql);
		if(is_array($_aProd)){
			if($_aProd["sDescShort"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aProd["sDescShort"])),100,false,false);
			}elseif($_aProd["sDescFull"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aProd["sDescFull"])),100,false,false);
			}
		}
	}
	if($iKeyType==6 && isset($_GET["i"]) && is_numeric($_GET["i"])){ // Agenda
		$_sql = "SELECT sTitle,sContent FROM tb_calendar WHERE bVisible=1 AND iKey=".$_GET["i"];
		$_aPage = getTableColumns($_sql);
		if(is_array($_aPage)){
			if($_aPage["sContent"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aPage["sContent"])),100,false,false);
			}elseif($_aProd["sTitle"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aPage["sTitle"])),100,false,false);
			}
		}	
	}

	if($iKeyType==7 && isset($_GET["i"]) && is_numeric($_GET["i"])){ // Fotoalbum
		$_sql = "SELECT sTitle,sContent FROM tb_media_photobooks WHERE bVisible=1 AND iKey=".$_GET["i"];
		$_aPage = getTableColumns($_sql);
		if(is_array($_aPage)){
			if($_aPage["sContent"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aPage["sContent"])),100,false,false);
			}elseif($_aProd["sTitle"]!=""){
				$_sMetaDesc = CutString(str_replace(chr(13)," ",strip_tags($_aPage["sTitle"])),100,false,false);
			}
		}	
	}
	if($_sMetaDesc!="")$_sReturn .= '<META NAME="DESCRIPTION" CONTENT="'.$_sMetaDesc.'">'.chr(13);

	if(isset($sMetaKeywords) && trim($sMetaKeywords)!="")$_sReturn .= '<META NAME="KEYWORDS" CONTENT="'.$sMetaKeywords.'">'.chr(13);



	return $_sReturn;

}

function renderPageTitle(){
	global $iKeyNode,$iPageLevel,$sSiteTitle,$iShopCatLevel,$aShopCatLevel,$sSiteLanguage,$iKeyType;
//define("WEBSITE_ID_TITLE",SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.$PAGE_TITLE.SITE_ID_TITLE_SUFFIX);
	if(isset($_GET["go"]) && $_GET["go"]==-100){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Login").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]==-101){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Login")." - ".translate("Account_aanmaken").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]==-102){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Gebruikersaccount")." - ".translate("Gegevens_wijzigen").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]==-104){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Login")." - ".translate("Wachtwoord_vergeten").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]==-105){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Gebruikersaccount").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]==-106){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("Gebruikersaccount")." - ".translate("Wachtwoord_wijzigen").SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["go"]) && $_GET["go"]=="sitemap"){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX."Sitemap".SITE_ID_TITLE_SUFFIX;
	}elseif(isset($_GET["q"]) || isset($_GET["query"])){
		return SITE_ID_TITLE.SITE_ID_TITLE_SEPERATOR.SITE_ID_TITLE_PREFIX.translate("search").SITE_ID_TITLE_SUFFIX;
	}else{
		$_sExtend = "";
		// Extend shop category
		if(isset($_GET["shop"]) && is_numeric($_GET["shop"])){
			$_sql = "SELECT iKey,sTitle".strtoupper($sSiteLanguage)." sTitle FROM tb_shop_categories WHERE iKey=".$_GET["shop"];
			$_aProd = getTableColumns($_sql);
			if(is_array($_aProd)){
				$_sExtend .= SITE_ID_TITLE_SEPERATOR.$_aProd["sTitle"];
			}
		}
		// Extend shop product
		if(isset($_GET["product"]) && is_numeric($_GET["product"])){
			$_sql = "SELECT iKey,sTitle".strtoupper($sSiteLanguage)." sTitle FROM tb_shop_products WHERE iKey=".$_GET["product"];
			$_aProd = getTableColumns($_sql);
			if(is_array($_aProd)){
				$_sExtend .= SITE_ID_TITLE_SEPERATOR.strip_tags($_aProd["sTitle"]);
			}
		}
		if(isset($_GET["order"])){
			$_sExtend .= SITE_ID_TITLE_SEPERATOR.translate("Bestel");
		}
		// Extend nieuwsmodule
		if($iKeyType==5 && isset($_GET["i"]) && is_numeric($_GET["i"])){
			$_sql = "SELECT sTitle FROM tb_news WHERE bVisible=1 AND iKey=".$_GET["i"];
			$_aPage = getTableColumns($_sql);
			if(is_array($_aPage)){
				if($_aPage["sTitle"]!=""){
					$_sExtend .= SITE_ID_TITLE_SEPERATOR.strip_tags($_aPage["sTitle"]);
				}
			}	
		}
		// Extend agendamodule
		if($iKeyType==6 && isset($_GET["i"]) && is_numeric($_GET["i"])){
			$_sql = "SELECT sTitle FROM tb_calendar WHERE bVisible=1 AND iKey=".$_GET["i"];
			$_aPage = getTableColumns($_sql);
			if(is_array($_aPage)){
				if($_aPage["sTitle"]!=""){
					$_sExtend .= SITE_ID_TITLE_SEPERATOR.strip_tags($_aPage["sTitle"]);
				}
			}	
		}
		// Extend fotoalbum
		if($iKeyType==7 && isset($_GET["i"]) && is_numeric($_GET["i"])){
			$_sql = "SELECT sTitle FROM tb_media_photobooks WHERE bVisible=1 AND iKey=".$_GET["i"];
			$_aPage = getTableColumns($_sql);
			if(is_array($_aPage)){
				if($_aPage["sTitle"]!=""){
					$_sExtend .= SITE_ID_TITLE_SEPERATOR.strip_tags($_aPage["sTitle"]);
				}
			}	
		}

		return WEBSITE_ID_TITLE.$_sExtend;
	}
}
?>