<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function nl2mysql($dt){
	$dt=str_replace("/","-",str_replace("\\","-",$dt));
	$aDate=split("-",$dt);
	if(count($aDate)==3){
		return $aDate[2]."-".$aDate[1]."-".$aDate[0];
	}else{
		return false;
	}
}
function mysql2unix($dt,$format){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return $dt;
		$_date = $_aParts[0];
		$_time = $_aParts[1];
		$_aDateParts = split("-",$_date);
		if(count($_aDateParts)!=3)return $dt;
		if($_aDateParts[0]==0 && $_aDateParts[1]==0 && $_aDateParts[2]==0)return "-";
		$dt_date = round($_aDateParts[2])."-".round($_aDateParts[1])."-".$_aDateParts[0];

		$_aTimeParts = split(":",$_time);
		if(count($_aTimeParts)!=3)return $dt;
		// Is er tijd?
		if($_aTimeParts[0]==0 && $_aTimeParts[1]==0 && $_aTimeParts[2]=="01"){
			$unix_stamp=gmmktime(0,0,0,$_aDateParts[1],$_aDateParts[2],$_aDateParts[0]);
		}else{
			$unix_stamp=gmmktime($_aTimeParts[0],$_aTimeParts[1],$_aTimeParts[2],$_aDateParts[1],$_aDateParts[2],$_aDateParts[0]);
		}

		$dt = gmstrftime($format,$unix_stamp);
	}
	return $dt;
}
/*  w e e k n u m b e r  -------------------------------------- //
weeknumber returns a week number from a given date (>1970, <2030)
Wed, 2003-01-01 is in week 1
Mon, 2003-01-06 is in week 2
Wed, 2003-12-31 is in week 53, next years first week
Be careful, there are years with 53 weeks.
// ------------------------------------------------------------ */ 

function weeknumber ($y, $m, $d) {
    $wn = strftime("%W",mktime(0,0,0,$m,$d,$y));
    $wn += 0; # wn might be a string value
    $firstdayofyear = getdate(mktime(0,0,0,1,1,$y));
    if ($firstdayofyear["wday"] != 1)    # if 1/1 is not a Monday, add 1
        $wn += 1;
    return ($wn);
}    # function weeknumber

/*  d a t e f r o m w e e k  ---------------------------------- //
From a weeknumber, calculates the corresponding date
Input: Year, weeknumber and day offset
Output: Exact date in an associative (named) array
2003, 12, 0: 2003-03-17 (a Monday)
1995,  53, 2: 1995-12-xx
...
// ------------------------------------------------------------ */ 

function datefromweek ($y, $w, $o) {

    $days = ($w - 1) * 7 + $o;

    $firstdayofyear = getdate(mktime(0,0,0,1,1,$y));
    if ($firstdayofyear["wday"] == 0) $firstdayofyear["wday"] += 7; 
# in getdate, Sunday is 0 instead of 7
    $firstmonday = getdate(mktime(0,0,0,1,1-$firstdayofyear["wday"]+1,$y));
    $calcdate = getdate(mktime(0,0,0,$firstmonday["mon"], $firstmonday["mday"]+$days,$firstmonday["year"]));

    $date["year"] = $calcdate["year"];
    $date["month"] = $calcdate["mon"];
    $date["day"] = $calcdate["mday"];

    return ($date);

}    # function datefromweek 

function parseDate($dt,$format){
	switch($format){
		case 1: // datum+tijd + conversie
			$dt_date = substr(substr($dt,0,10),5);
			$dt_year = substr($dt,2,2);
			$a_date = split("-",$dt_date);
			$dt_date = $a_date[1]."-".$a_date[0];
			$dt_time =substr($dt,11,5);
			
			$dt = $dt_date."-".$dt_year." ".$dt_time;
			return $dt;
		break;
		case 2: // mysql date naar date
			$dt_date = substr($dt,5,5);
			$a_date = split("-",str_replace("/","-",$dt_date));
			$dt_date = $a_date[1]."-".$a_date[0];
			
			$dt = $dt_date;
			return $dt;
		break;
		case 3: // alleen datum + conversie
			$dt_date = substr($dt,5,5);
			$a_date = split("-",$dt_date);
			$dt_date = $a_date[1]."-".$a_date[0];
			
			$dt = $dt_date;
			return $dt;
		break;
		case 4: // datum+tijd + conversie
			$dt_date = substr(substr($dt,0,10),5);
			$dt_year = substr($dt,2,2);
			$a_date = split("-",$dt_date);
			$dt_date = $a_date[1]."-".$a_date[0];
			$dt_time =substr($dt,11,8);
			
			$dt = $dt_date." om ".$dt_time;
			return $dt;
		break;
		case 5: // datum+tijd
			$dt_date = substr($dt,0,5);
			$dt_date = str_replace("/","-",$dt_date);
			$a_date = split("-",$dt_date);
			$dt_date = $a_date[0]."-".$a_date[1];
			$dt_time = substr($dt,10,4);
			
			$dt = $dt_date." ".$dt_time;
			return $dt;
		break;
		case 6: // tijd
			$dt_time =substr($dt,11,5);
			
			$dt = $dt_time;
			return $dt;
		break;
	}
}
function datetime2locale($dt){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return $dt;
		$_date = $_aParts[0];
		$_time = $_aParts[1];
		$_aDateParts = split("-",$_date);
		if(count($_aDateParts)!=3)return $dt;
		if($_aDateParts[0]==0 && $_aDateParts[1]==0 && $_aDateParts[2]==0)return "-";
		$dt_date = round($_aDateParts[2])."-".round($_aDateParts[1])."-".$_aDateParts[0];

		$_aTimeParts = split(":",$_time);
		if(count($_aTimeParts)!=3)return $dt;
		// Is er tijd?
		if($_aTimeParts[0]==0 && $_aTimeParts[1]==0 && $_aTimeParts[2]=="01"){
			$dt_time="";
		}else{
			$dt_time = " @ ".$_aTimeParts[0].":".$_aTimeParts[1];
		}

		$dt = $dt_date.$dt_time;
	}
	return $dt;
}
function datetime2localetime($dt){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return "";
		$_time = $_aParts[1];

		$_aTimeParts = split(":",$_time);
		if(count($_aTimeParts)!=3)return "";
		// Is er tijd?
		if($_aTimeParts[0]==0 && $_aTimeParts[1]==0 && $_aTimeParts[2]=="01"){
			$dt_time="";
		}else{
			$dt_time = $_aTimeParts[0].":".$_aTimeParts[1];
		}

		$dt = $dt_time;
	}
	return $dt;
}
function datetime2dateinput($dt){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return "";
		$_date = $_aParts[0];
		$_aDateParts = split("-",$_date);
		if(count($_aDateParts)!=3)return "";
		if($_aDateParts[0]==0 && $_aDateParts[1]==0 && $_aDateParts[2]==0)return "";
		$dt_date = round($_aDateParts[2])."-".round($_aDateParts[1])."-".$_aDateParts[0];
		$dt = $dt_date;
	}
	return $dt;
}
function datetime2hours($dt){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return "";
		$_date = $_aParts[0];
		$_time = $_aParts[1];
		$_aDateParts = split("-",$_date);
		if(count($_aDateParts)!=3)return "";
		if($_aDateParts[0]==0 && $_aDateParts[1]==0 && $_aDateParts[2]==0)return "";
		$_aTimeParts = split(":",$_time);
		if(count($_aTimeParts)!=3)return"";
		// Is er tijd?
		if($_aTimeParts[0]==0 && $_aTimeParts[1]==0 && $_aTimeParts[2]=="01"){
			$dt_time="";
		}else{
			$dt_time = round($_aTimeParts[0]);
		}

		$dt = $dt_time;
	}
	return $dt;
}
function datetime2minutes($dt){
	if($dt != ""){
		$_aParts = split(" ",$dt);
		if(count($_aParts)!=2)return "";
		$_date = $_aParts[0];
		$_time = $_aParts[1];
		$_aDateParts = split("-",$_date);
		if(count($_aDateParts)!=3)return "";
		if($_aDateParts[0]==0 && $_aDateParts[1]==0 && $_aDateParts[2]==0)return "";
		$_aTimeParts = split(":",$_time);
		if(count($_aTimeParts)!=3)return"";
		// Is er tijd?
		if($_aTimeParts[0]==0 && $_aTimeParts[1]==0 && $_aTimeParts[2]=="01"){
			$dt_time="";
		}else{
			$dt_time = round($_aTimeParts[1]);
		}

		$dt = $dt_time;
	}
	return $dt;
}
# PHP Calendar (version 2.3), written by Keith Devens
# http://keithdevens.com/software/php_calendar
#  see example at http://keithdevens.com/weblog
# License: http://keithdevens.com/software/license

function generate_calendar($year, $month, $days = array(), $day_name_length = 3, $month_href = NULL, $first_day = 0, $pn = array()){
	$first_of_month = gmmktime(0,0,0,$month,1,$year);
	#remember that mktime will automatically correct if invalid dates are entered
	# for instance, mktime(0,0,0,12,32,1997) will be the date for Jan 1, 1998
	# this provides a built in "rounding" feature to generate_calendar()

	$day_names = array(); #generate all the day names according to the current locale
	for($n=0,$t=(3+$first_day)*86400; $n<7; $n++,$t+=86400) #January 4, 1970 was a Sunday
		$day_names[$n] = ucfirst(gmstrftime('%A',$t)); #%A means full textual day name

	list($month, $year, $month_name, $weekday) = explode(',',gmstrftime('%m,%Y,%B,%w',$first_of_month));
	$weekday = ($weekday + 7 - $first_day) % 7; #adjust for $first_day
	$title   = htmlentities(ucfirst($month_name)).'&nbsp;'.$year;  #note that some locales don't capitalize month and day names

	#Begin calendar. Uses a real <caption>. See http://diveintomark.org/archives/2002/07/03
	@list($p, $pl) = each($pn); @list($n, $nl) = each($pn); #previous and next links, if applicable
	if($p) $p = '<span class="calendar-prev">'.($pl ? '<a href="'.htmlspecialchars($pl).'">'.$p.'</a>' : $p).'</span>&nbsp;';
	if($n) $n = '&nbsp;<span class="calendar-next">'.($nl ? '<a href="'.htmlspecialchars($nl).'">'.$n.'</a>' : $n).'</span>';
	$calendar = '<table class="calendar" cellpadding="0" cellspacing="0">'."\n".
		'<caption class="calendar-month">'.$p.($month_href ? '<a href="'.htmlspecialchars($month_href).'">'.$title.'</a>' : $title).$n."</caption>\n<tr>";

	if($day_name_length){ #if the day names should be shown ($day_name_length > 0)
		#if day_name_length is >3, the full name of the day will be printed
		foreach($day_names as $d)
			$calendar .= '<th abbr="'.htmlentities($d).'">'.htmlentities($day_name_length < 4 ? substr($d,0,$day_name_length) : $d).'</th>';
		$calendar .= "</tr>\n<tr>";
	}

	if($weekday > 0) $calendar .= '<td colspan="'.$weekday.'">&nbsp;</td>'; #initial 'empty' days
	for($day=1,$days_in_month=gmdate('t',$first_of_month); $day<=$days_in_month; $day++,$weekday++){
		if($weekday == 7){
			$weekday   = 0; #start a new week
			$calendar .= "</tr>\n<tr>";
		}
		if(isset($days[$day]) and is_array($days[$day])){
			@list($link, $classes, $content) = $days[$day];
			if(is_null($content))  $content  = $day;
			$calendar .= '<td'.($classes ? ' class="'.htmlspecialchars($classes).'">' : '>').
				($link ? '<a href="'.htmlspecialchars($link).'">'.$content.'</a>' : $content).'</td>';
		}
		else $calendar .= "<td>$day</td>";
	}
	if($weekday != 7) $calendar .= '<td colspan="'.(7-$weekday).'">&nbsp;</td>'; #remaining "empty" days

	return $calendar."</tr>\n</table>\n";
}
function FullDate($dtDate) {
if($dtDate != "0000-00-00 00:00:00"){
 $temp_date = $dtDate;

 $dag = substr($temp_date, 8, 2);
 $maand = substr($temp_date, 5, 2);
 $jaar = substr($temp_date, 0, 4);
 $minuut = substr($temp_date, 14, 2);
 $uur = substr($temp_date, 11, 2);
 $sec = substr($temp_date, 17, 2);
 
 $arraymaand = array("januari", "februari", "maart", "april", "mei", "juni", "juli", "augustus", "september", "oktober", "november", "december"); 

 return $dag." ".$arraymaand[$maand - 1]." ".$jaar;

 } else {
 return "-";
}
}
function mkagendadate($dtDate){

//$dtDate = gmdate("d m Y",$dtDate);
$dtDayOfWeek = gmdate("D",$dtDate);
$dtMonth = gmdate("m",$dtDate);
$dtDay = gmdate("d",$dtDate);

 switch($dtDayOfWeek){
  case "Mon":
   $dtDayOfWeek = "Maandag";
   break;
  case "Tue":
   $dtDayOfWeek = "Dinsdag";
   break;
  case "Wed":
   $dtDayOfWeek = "Woensdag";
   break;
  case "Thu":
   $dtDayOfWeek = "Donderdag";
   break;
  case "Fri":
   $dtDayOfWeek = "Vrijdag";
   break;
  case "Sat":
   $dtDayOfWeek = "Zaterdag";
   break;
  case "Sun":
   $dtDayOfWeek = "Zondag";
   break;
 }

 switch($dtMonth){
  case "01":
   $dtMonth = "januari";
   break;
  case "02":
   $dtMonth = "februari";
   break;
  case "03":
   $dtMonth = "maart";
   break;
  case "04":
   $dtMonth = "april";
   break;
  case "05":
   $dtMonth = "mei";
   break;
  case "06":
   $dtMonth = "juni";
   break;
  case "07":
   $dtMonth = "juli";
   break;
  case "08":
   $dtMonth = "augustus";
   break;
  case "09":
   $dtMonth = "september";
   break;
  case "10":
   $dtMonth = "oktober";
   break;
  case "11":
   $dtMonth = "november";
   break;
  case "12":
   $dtMonth = "december";
   break;

 }
 if($dtDay <> "10" && $dtDay <> "20" && $dtDay <> "30"){ $dtDay = trim($dtDay,"0");}
 return $dtDayOfWeek." ".$dtDay." ".$dtMonth;
}
?>