<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function getThumb($sPath_,$iW_,$iH_){
	global $sLoc;
	$sPath_ = urldecode($sPath_);
	$sPath_ = str_replace("[PLUS]","+",$sPath_);
	//$sPath_ = (is_file($sPath_)) ? $sPath_ : $sLoc.$sPath_;
	$sFile_ = end(explode('/',$sPath_));
	$sFilePath_ = substr($sPath_,0,strlen($sPath_)-(strlen($sFile_)+1));
	$sFileThumb_ = $iW_."x".$iH_."_".$sFile_;
	$sPathThumb_ = $sFilePath_."/thumbs/";
	$sThumb = $sPathThumb_.$sFileThumb_;
	if($iW_ == 0 && $iH_ == 0)$sThumb=$sPath_;

	if(is_file($sThumb)){ // Thumb bestaat
		$sReturn_ = $sThumb;
	}else{ // Thumb moet gegenereerd worden
		if(is_file($sPath_) || is_file(dirname($_SERVER['SCRIPT_FILENAME'])."/".$sPath_)){ // Thumb genereren
			if(!is_dir(dirname($_SERVER['SCRIPT_FILENAME']).'/'.$sPathThumb_))mkdir(dirname($_SERVER['SCRIPT_FILENAME']).'/'.$sPathThumb_);
			$file=dirname($_SERVER['SCRIPT_FILENAME'])."/".$sPath_;
			$filename=dirname($_SERVER['SCRIPT_FILENAME'])."/".$sThumb;
			$thumbnailHeight=$iH_;
			$thumbnailWidth=$iW_;
			
			$contentType = "";
			$extension = strtolower(substr(strrchr($file, "."), 1));
			switch ($extension) {
				case "gif":		if($src = imagecreatefromgif($file)); $contentType="image/gif"; break;
				case "jpg":		// fall through
				case "jpeg":	$src = imagecreatefromjpeg($file); $contentType="image/jpeg"; break;
				case "png":		$src = imagecreatefrompng($file); $contentType="image/png"; break;
				default:	die(); break;
			}
			$srcWidth = imagesx($src);
			$srcHeight = imagesy($src);
			$srcAspectRatio = ($srcWidth!=0 && $srcHeight!=0) ? $srcWidth / $srcHeight : 1;
			
			$maxAge = 3600; // one hour
			//Header("Cache-Control: public, max-age=$maxAge, must-revalidate");
			//Header("Expires: ".gmdate("D, d M Y H:i:s", time()+$maxAge)." GMT");
			
			if ($srcHeight<=$thumbnailHeight && $srcWidth<=$thumbnailWidth) {
				//header("Content-Type: $contentType");
				//readfile($file);
				$sReturn_ = $sPath_;
			} else {
				if ($srcWidth > $srcHeight) {
					$thumbWidth = $thumbnailWidth;
					$thumbHeight = $thumbWidth / $srcAspectRatio;
				} else {
					$thumbHeight = $thumbnailHeight;
					$thumbWidth = $thumbHeight * $srcAspectRatio;
				}
				if(!is_numeric($thumbWidth) || $thumbWidth<3){
					$thumbWidth = 3;
					$thumbHeight = $iH_;
				}
				if(!is_numeric($thumbHeight) || $thumbHeight<3){
					$thumbHeight = 3;
				}

				if (function_exists('imagecreatetruecolor')) {
					$thumb = imagecreatetruecolor($thumbWidth, $thumbHeight);
				} else {
					$thumb = imagecreate($thumbWidth, $thumbHeight);
				}
				$background_color = imagecolorallocate($thumb, 255, 255, 255);
				imagecopyresampled($thumb, $src, 0, 0, 0, 0, $thumbWidth, $thumbHeight, $srcWidth, $srcHeight);
				imagejpeg($thumb, $filename,100);

				$sReturn_ = $sThumb;
			}
		}else{
			$sReturn_ = "No image found: ".$sPath_;
		}
	}

	return $sReturn_;
}
//File will be rewritten if already exists
function safeDir($str_){
	$str_=str_replace("\\","",$str_);
	$str_=str_replace("/","",$str_);
	$str_=str_replace("*","",$str_);
	$str_=str_replace(":","",$str_);
	$str_=str_replace("?","",$str_);
	$str_=str_replace("\"","",$str_);
	$str_=str_replace("<","",$str_);
	$str_=str_replace(">","",$str_);
	$str_=str_replace("|","",$str_);
	return $str_;
}
function write_file($filename,$newdata) {
	$f=fopen($filename,"w");
	fwrite($f,$newdata);
	fclose($f);  
}

function append_file($filename,$newdata) {
	$f=fopen($filename,"a");
	fwrite($f,$newdata);
	fclose($f);  
}

function read_file($filename) {
	$f=fopen($filename,"r");
	$data=(filesize($filename)>0)?fread($f,filesize($filename)):"";

	fclose($f);  
	return $data;
}
function del_file($str)
{
   foreach(glob($str) as $fn) { 
       unlink($fn); 
   } 
}
function deltree($f) {
  if (is_dir($f)) {
    foreach(glob($f.'/*') as $sf) {
      if (is_dir($sf) && !is_link($sf)) {
        deltree($sf);
        if(is_link($sf))rmdir($sf); 
          
      } else {
        unlink($sf);
      }   
    }   
  }

  rmdir($f);
}
function GetFolderSize($d ="." ) { 
    //  kasskooye and patricia benedetto 
    $h = @opendir($d); 
    if($h==0)return 0; 
	$sf='';
    while ($f=readdir($h)){ 
        if ( $f!= "..") { 
            $sf+=filesize($nd=$d."/".$f); 
            if($f!="."&&is_dir($nd)){ 
                $sf+=GetFolderSize ($nd); 
            } 
        } 
    } 
    closedir($h); 
    return $sf ; 
}
function full_rmdir($dirname)
    {
    if ($dirHandle = opendir($dirname))
        {
        $old_cwd = getcwd();
        chdir($dirname);
        
        while ($_file = readdir($dirHandle))
            {
            if ($_file == '.' || $_file == '..') continue;
            
            if (is_dir($_file))
                {
                if (!rmdir_rf($_file)) return false;
                }
            else
                {
                if (!unlink($_file)) return false;
                }
            }
        
        closedir($dirHandle);
        chdir($old_cwd);
        if (!rmdir($dirname)) return false;
        
        return true;
        }
    else
        {
        return false;
        }
   }
function rmdir_rf($dirname2) {
    if ($dirHandle2 = opendir($dirname2)) {
        chdir($dirname2);
        while ($_file2 = readdir($dirHandle2)) {
            if ($_file2 == '.' || $_file2 == '..') continue;
            if (is_dir($_file2)) rmdir_rf($_file2);
            else unlink($_file2);
        }
        chdir('..');
        rmdir($dirname2);
        closedir($dirHandle2);
    }
}
?>