<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class cFormBuilder
{
	// Form
	var $sAction;
	var $sMethod;
	var $sEncType;
	var $sID;
	var $iColumnWidth;
	var $sName;
	var $sTarget;
	var $sUpdateKey;
	var $sCSS;
	var $sClass;
	var $sExtra;
	var $bMd5;
	var $sSubmitType;
	var $sOnSuccess;
	var $sError;
	var $sValidation;
	var $sButtonSubmit;
	var $sButtonReset;

	// Database
	var $sDbTable;
	var $iKeyUpdate;

	// Construct
	function cFormBuilder($sID,$sDbTable=NULL,$sSubmitType="form"){
		$this->sID = $sID;
		$this->sName = $this->sID;
		$this->sDbTable = $sDbTable;
		$this->sSubmitType = $sSubmitType;
		$this->bMd5 = false;

		// Default values
		$this->sAction = (isset($_SERVER['QUERY_STRING'])&&$_SERVER['QUERY_STRING']!="")?$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']:$_SERVER['PHP_SELF'];
		$this->sMethod = 'post';
		$this->sRows = '';
		$this->sOnSuccess = 'submitSuccess';
		$this->sValidation = '';
		$this->iColumnWidth = 180;
		$this->sUpdateKey = "iKey";
		if($_POST)$this->submitForm();
	}
/* ===============================================================================================================================
 Add a row to the form
================================================================================================================================== */
	function addRow($sType,$sName,$sTitle="",$sValues=""){
		$sName_global = $sName;
		if($this->sSubmitType=="form"){
			// Get db value
			$_sValue = ($sType != "array" && $this->iKeyUpdate!="") ? html_entity_decode(getValue($this->sDbTable,"iKey",$sName,$this->iKeyUpdate)) : "";
		}elseif($this->sSubmitType=="getvalue"){
			$sName = $this->iKeyUpdate."_".$sName;
			$_sValue = ($sType != "array" && $this->iKeyUpdate!="") ?  Get_Value($sName) : "";
		}
		// Parse values
		if($sValues!=""){
			$_aValues=explode(",",$sValues);
			foreach($_aValues as $_sValueRow){
				$_aValue=explode("::",trim($_sValueRow));
				$_aName[$_aValue[0]] = $_aValue[1];
			}
		}

		// Create column cells
		$sColumn1 = '';
		$sColumn2 = '';

		// Add hidden values
		if(isset($_aName["allownull"])&&$_aName["allownull"]=='false')$sColumn1 .= '<input type="hidden" name="'.$sName.'_allownull" value="'.$_aName["allownull"].'" />';
		if(isset($_aName["allowduplicate"])&&$_aName["allowduplicate"]=='false')$sColumn1 .= '<input type="hidden" name="'.$sName.'_allowduplicate" value="'.$_aName["allowduplicate"].'" />';

		// Required / unique
		global $sLoc;
		$_sExtra = "";
		$_sExtra .= (isset($_aName["allownull"])&&$_aName["allownull"]=='false') ? ' <img src="'.$sLoc.'lib/images/required.gif" style="cursor:help" ext:qtip="'.xTranslate("Verplicht").'" ext:width="66" align="absmiddle" />':'';
		$_sExtra .= (isset($_aName["allowduplicate"])&&$_aName["allowduplicate"]=='false') ? ' <img src="'.$sLoc.'lib/images/unique.gif" style="cursor:help" ext:qtip="'.xTranslate("Uniek").'" ext:width="100" align="absmiddle" />':'';

		$sColumn2 = '&nbsp;'.$_sExtra;

		// Icon
		$_sIcon = (isset($_aName["icon"])&&$_aName["icon"]!='') ? '<img src="'.$sLoc.'lib/images/'.$_aName["icon"].'" border="0" align="absmiddle" />' : '';

		// Validation
		//$this->sValidation .= (isset($_aName["allownull"])&&$_aName["allownull"]=='false') ? 'if(Ext.get("").value=="")submitform="Geen";':'';

		switch($sType){
/* ===============================================================================================================================
 			Row type header
================================================================================================================================== */
			case "header":
				$this->sRows .= '<tr><td colspan="4" style="height:4px;"></td></tr><tr><td width="25">&nbsp;</td><td colspan="3"><h2>'.$sName_global.'</h2></td></tr><tr><td colspan="4" style="height:4px;"></td></tr>';
				return;
			break;
/* ===============================================================================================================================
 			Row type text
================================================================================================================================== */
			case "text":
				$this->sRows .= '<tr><td width="25">&nbsp;</td><td width="'.$this->iColumnWidth.'" valign="top">'.$sName.'</td><td colspan="2"><b>'.$sTitle.'</b></td></tr>';
				return;
			break;
/* ===============================================================================================================================
 			Row type hidden
================================================================================================================================== */
			case "hidden":
				$_sTextValue=(isset($_sValue)&&$_sValue!="")?' value="'.$_sValue.'"':'';
				$_sTextValue=(isset($_aName["default"]))?' value="'.$_aName["default"].'"':'';

				$this->sRows .='<input type="hidden" name="'.$sName.'" id="'.$sName.'" '.$_sTextValue.' />';
				return;
			break;
/* ===============================================================================================================================
 			Row type image
================================================================================================================================== */
			case "image":
				$_sDefaultDir=(isset($_aName["dir"]))?$_aName["dir"]:'';
				$_sTextValue=(isset($_aName["default"]))?' value="'.$_aName["default"].'"':'';
				$_sTextValue=(isset($_sValue)&&$_sValue!="")?' value="'.$_sValue.'"':$_sTextValue;
				$_sTextSize=(isset($_aName["size"]))?' size="'.$_aName["size"].'"':32;
				$_sTextMaxLen=(isset($_aName["maxlength"]))?' maxlength="'.$_aName["maxlength"].'"':'';

				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"': '';

				$sColumn1 .= '<input type="text" class="x-form-text x-form-field" name="'.$sName.'" id="'.$sName.'" '.$_sTextValue.$_sTextSize.$_sTextMaxLen.$_sDisabled.' /> <a href="javascript:;" class="sel" onclick="popUp(\'../filedialog/?ext=1&basepath='.encrypt("../../../".$_sDefaultDir).'&i=0&id='.$sName.'\',600,500,true)"><img src="../../lib/images/icons/cursor.gif" border="0" align="absmiddle" /> '.GET.'</a> <a href="javascript:;" class="sel" onclick="document.getElementById(\''.$sName.'\').value=\'\';"><img src="../../lib/images/icons/delete.gif" border="0" align="absmiddle" /> '.REMOVE.'</a> <a href="javascript:;" class="sel" onclick="if(document.getElementById(\''.$sName.'\').value!=\'\'){popUp(\'../../../\' + document.getElementById(\''.$sName.'\').value,600,500,true);}"><img src="../../lib/images/icons/zoom.gif" border="0" align="absmiddle" /> '.SELECT.'</a>';

			break;
/* ===============================================================================================================================
 			Row type textfield
================================================================================================================================== */
			case "textfield":
				$_sTextValue=(isset($_aName["default"]))?' value="'.$_aName["default"].'"':'';
				$_sTextValue=(isset($_sValue)&&$_sValue!="")?' value="'.$_sValue.'"':$_sTextValue;
				$_sTextSize=(isset($_aName["size"]))?' size="'.$_aName["size"].'"':32;
				$_sTextMaxLen=(isset($_aName["maxlength"]))?' maxlength="'.$_aName["maxlength"].'"':'';

				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"': '';

				$sColumn1 .= '<input type="text" class="x-form-text x-form-field" name="'.$sName.'" id="'.$sName.'" '.$_sTextValue.$_sTextSize.$_sTextMaxLen.$_sDisabled.' />';

			break;
/* ===============================================================================================================================
 			Row type textfield double (2 rows)
================================================================================================================================== */
			case "textfield_double":
				$_sTextValue=(isset($_aName["default"]))?' value="'.$_aName["default"].'"':'';
				$_sTextValue=(isset($_sValue)&&$_sValue!="")?' value="'.$_sValue.'"':$_sTextValue;
				$_sTextSize=(isset($_aName["size"]))?' size="'.$_aName["size"].'"':32;
				$_sTextMaxLen=(isset($_aName["maxlength"]))?' maxlength="'.$_aName["maxlength"].'"':'';

				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"': '';

				$_sBgColor = (isset($_sValue)&&$_sValue!="") ? '': 'background-color:#ff0000;';

				$sColumn1 .= '<input type="text" class="x-form-text x-form-field" name="'.$sName.'" id="'.$sName.'" '.$_sTextValue.$_sTextSize.$_sTextMaxLen.$_sDisabled.' style="width:100%;'.$_sBgColor.'" />';

				// Add help
				$sHelp = (isset($_aName["helpid"])) ? '<tr><td width="25" valign="top">'.getHelpVar($_aName["helpid"]).'</td>':'<tr><td width="25">&nbsp;</td>';
		
				$sColumn1 .= (isset($_aName["after"])) ? $_aName["after"] : '';
				$this->sRows .= $sHelp.'<td valign="top"><label for="'.$sName.'">'.$sTitle.'</label></td></tr>';
				$this->sRows .= '<tr><td width="25">&nbsp;</td><td>'.$_sIcon.$sColumn1.'</td></tr>';
				$this->sRows .= '<tr><td colspan="2" height="5"></td></tr>';

return;
			break;
/* ===============================================================================================================================
 			Row type textarea
================================================================================================================================== */
			case "textarea":
				$_sTextValue=(isset($_aName["default"])) ? $_aName["default"]:'';
				$_sTextValue=(isset($_sValue)&&$_sValue!="") ? $_sValue:$_sTextValue;
				$_sTextRows=(isset($_aName["size"])) ? $_aName["rows"]:4;
				$_sTextWidth=(isset($_aName["width"])) ? $_aName["width"]:"97%";

				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"': '';

				$sColumn1 .= '<textarea class="x-form-field" '.$_sDisabled.' style="width:'.$_sTextWidth.';" rows='.$_sTextRows.' name="'.$sName.'" id="'.$sName.'">'.$_sTextValue.'</textarea>';
			break;
/* ===============================================================================================================================
 			Row type password
================================================================================================================================== */
			case "password":
				$this->bMd5 = true;
				$_sTextValue=(isset($_aName["default"]))?' value="'.$_aName["default"].'"':'';
				$_sTextValue=' value="******"'; //(isset($_sValue)&&$_sValue!="")?' value="'.$_sValue.'"':'';
				$_sTextSize=(isset($_aName["size"]))?' size="'.$_aName["size"].'"':32;
				$_iSize=(isset($_aName["size"]))?$_aName["size"] :32;
				$_sTextMaxLen=(isset($_aName["maxlength"]))?' maxlength="'.$_aName["maxlength"].'"':'';
				$_sSizeEdit=(isset($_aName["sizeedit"]))?$_aName["sizeedit"]:40;
				$_sConfirm=(isset($_aName["confirm"]))?$_aName["confirm"]:false;

				$_sValue = (isset($_sValue)) ? $_sValue:"";

				$sColumn1 .= '<table border="0" cellspacing="0" cellpadding="0"><tr><td><input type="hidden" name="'.$sName.'" id="'.$sName.'" value="'.$_sValue.'" /><input type="text" name="t'.$sName.'" id="t'.$sName.'" disabled="disabled" onBlur="saveP'.$sName.'();" class="x-form-text x-form-field"  '.$_sTextValue.$_sTextSize.$_sTextMaxLen.' /></td>';
				$sColumn1 .= (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? '<td>&nbsp;</td></tr></table>' : '<td id="divt'.$sName.'" style="padding-left:4px"><a href="javascript:changeP'.$sName.'();"><img src="'.$sLoc.'lib/images/icons/pencil.gif" align="absmiddle" border="0" /></a></td></tr></table>';


				$sColumn1 .= '<script type="text/javascript">
function changeP'.$sName.'(){
	Ext.get("t'.$sName.'").dom.size = '.$_sSizeEdit.';
	Ext.get("t'.$sName.'").dom.disabled = false;
	Ext.get("t'.$sName.'").dom.value = "";
	Ext.get("divt'.$sName.'").dom.innerHTML = "<a href=\"javascript:cancelP'.$sName.'();\"><img src=\"'.$sLoc.'lib/images/icons/action_stop.gif\" align=\"absmiddle\" border=\"0\" /></a> <a href=\"javascript:saveP'.$sName.'();\"><img src=\"'.$sLoc.'lib/images/icons/icon_accept.gif\" align=\"absmiddle\" border=\"0\" /></a>";
}
function saveP'.$sName.'(){
	Ext.get("'.$sName.'").dom.value = hex_md5(Ext.get("t'.$sName.'").dom.value);
	Ext.get("t'.$sName.'").dom.size = '.$_iSize.';
	Ext.get("t'.$sName.'").dom.value = "******";
	Ext.get("t'.$sName.'").dom.disabled = true;
	Ext.get("divt'.$sName.'").dom.innerHTML = \'<a href="javascript:changeP'.$sName.'();"><img src="'.$sLoc.'lib/images/icons/pencil.gif" align="absmiddle" border="0" /></a>\';
}
function cancelP'.$sName.'(){
	Ext.get("t'.$sName.'").dom.size = '.$_iSize.';
	Ext.get("t'.$sName.'").dom.value = "******";
	Ext.get("t'.$sName.'").dom.disabled = true;
	Ext.get("divt'.$sName.'").dom.innerHTML = \'<a href="javascript:changeP'.$sName.'();"><img src="'.$sLoc.'lib/images/icons/pencil.gif" align="absmiddle" border="0" /></a>\';
}
</script>';
			break;
/* ===============================================================================================================================
 			Row type list
================================================================================================================================== */
			case "list":
				$bHasEmpty_ = (isset($_aName["allownull"])&&$_aName["allownull"]=='false') ? false : true;
				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? true : false;

				// Ext combo
				$width_ = (isset($_aName["size"])) ? 'width:'.$_aName["size"] : "grow: true";
				$disabled_ = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? "true" : "false";
				$forceSelection_ = (isset($_aName["allownull"])&&$_aName["allownull"]=="false") ? "true" : "false";
				$sColumn1 .= '<script type="text/javascript">Ext.onReady(function(){var converted = new Ext.form.ComboBox({typeAhead: true,triggerAction: "all",transform:"'.$sName.'",'.$width_.',editable:'.$forceSelection_.',disabled:'.$disabled_.',forceSelection:'.$forceSelection_.'	});});</script>';

				$_aName["listwhere"] = (isset($_aName["listwhere"])) ? "WHERE ".$_aName["listwhere"] : "";

				$sColumn1 .= createList2("SELECT ".$_aName["listvalue"].",".$_aName["listtitle"]." FROM ".$_aName["listtable"]." ".$_aName["listwhere"]." ORDER BY ".$_aName["listtitle"]." ASC",$sName,$_aName["listtitle"],$_aName["listvalue"],$_sValue,$sStyle_=NULL,$sJavaScript_=NULL,$bHasEmpty_,$_sDisabled);

			break;
/* ===============================================================================================================================
 			Row type list
================================================================================================================================== */
			case "customlist":
				$bHasEmpty_ = (isset($_aName["allownull"])&&$_aName["allownull"]=='false') ? false : true;
				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? true : false;

				// Ext combo
				$width_ = (isset($_aName["size"])) ? 'width:'.$_aName["size"] : "grow: true";
				$disabled_ = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? "true" : "false";
				$forceSelection_ = (isset($_aName["allownull"])&&$_aName["allownull"]=="false") ? "true" : "false";
				$sColumn1 .= '<script type="text/javascript">Ext.onReady(function(){var converted = new Ext.form.ComboBox({typeAhead: true,triggerAction: "all",transform:"'.$sName.'",'.$width_.',editable:'.$forceSelection_.',disabled:'.$disabled_.',forceSelection:'.$forceSelection_.'	});});</script>';

				$sColumn1 .= '<select name="'.$sName.'" id="'.$sName.'">';
				$sColumn1 .= ($bHasEmpty_ == true) ? '<option value=""></option>' : '';

				$aOptions_ = split("//",$_aName["list"]);
				for($i_=0;$i_<count($aOptions_);$i_++){
					$sColumn1 .= '<option value="'.$i_.'">'.$aOptions_[$i_].'</option>';
				}
				$sColumn1 .= '</select>';

				//$sColumn1 .= createList2("SELECT ".$_aName["listvalue"].",".$_aName["listtitle"]." FROM ".$_aName["listtable"]." ORDER BY ".$_aName["listtitle"]." ASC",$sName,$_aName["listtitle"],$_aName["listvalue"],$_sValue,$sStyle_=NULL,$sJavaScript_=NULL,$bHasEmpty_,$_sDisabled);

			break;
/* ===============================================================================================================================
 			Row type link
================================================================================================================================== */
			case "link":
				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"' : '';
				$sColumn1 .= '<input name="link[]" id="'.$sName.'" type="checkbox" value="'.$sName.'" checked'.$_sDisabled.' />';
			break;
/* ===============================================================================================================================
 			Row type array
================================================================================================================================== */
			case "array":
				if(isset($_aName["column"])&&$_aName["column"]!='')
					$_sValue = getValue($this->sDbTable,"iKey",$_aName["column"],$this->iKeyUpdate);
				else
					die("No array column specified.");

				$_sOptionText = (isset($_aName["label"])&&$_aName["label"]!='') ? ' '.$_aName["label"] : '';

				$_sValue = explode(",",$_sValue);
				$_sChecked = (in_array($sName,$_sValue)) ? " checked": "";

				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"' : '';
				$this->sRows .='<input type="hidden" name="'.$_aName["column"].'[]" value="NULL" />';
				$sColumn1 .= '<input name="'.$_aName["column"].'[]" id="'.$sName.'" type="checkbox" value="'.$sName.'"'.$_sChecked.$_sDisabled.' />'.$_sOptionText;
			break;
/* ===============================================================================================================================
 			Row type boolean
================================================================================================================================== */
			case "boolean":
				$_sValue=(isset($_aName["default"]) && $_sValue==NULL)?$_aName["default"]:$_sValue;
				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"' : '';
				$_sSelected0=($_sValue==false || $_sValue==NULL || $_sValue==0)?' checked="checked"':'';
				$_sSelected1=($_sValue==true || $_sValue==NULL || $_sValue==1)?' checked="checked"':'';

				$sColumn1 .= '<input type="radio" id="'.$sName.'1" name="'.$sName.'" value="1"'.$_sSelected1.$_sDisabled.' /><label for="'.$sName.'1">'.xTranslate("Ja").'</label>
<input type="radio" id="'.$sName.'0" name="'.$sName.'" value="0"'.$_sSelected0.$_sDisabled.' /><label for="'.$sName.'0">'.xTranslate("Nee").'</label>';

			break;
/* ===============================================================================================================================
 			Row type extranet list
================================================================================================================================== */
			case "extranetlist":
				// Ext combo
				$width_ = (isset($_aName["size"])) ? 'width:'.$_aName["size"] : "grow: true";
				$disabled_ = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? "true" : "false";
				$forceSelection_ = (isset($_aName["allownull"])&&$_aName["allownull"]=="false") ? "true" : "false";
				$sColumn1 .= '<script type="text/javascript">Ext.onReady(function(){var converted = new Ext.form.ComboBox({typeAhead: true,triggerAction: "all",transform:"'.$sName.'",'.$width_.',editable:'.$forceSelection_.',disabled:'.$disabled_.',forceSelection:'.$forceSelection_.'	});});</script>';

				$_sql="select iKey,sTitle from tb_structure where isnull(iKeyParent) and isnull(dDeleted) and iKeyType=15 order by iOrder asc,iKey asc";
				$_oRS=mysql_query($_sql);
				$_sDisabled = (isset($_aName["disabled"])&&$_aName["disabled"]=='true') ? ' disabled="disabled"' : '';
				if($_rs=mysql_fetch_array($_oRS)){
					$sColumn1 .= '<select name="'.$sName.'" id="'.$sName.'"'.$_sDisabled.'>';
					do{
						$sSelected = ($_sValue==$_rs["iKey"]) ? " selected": "";
						$sColumn1 .= '<option value="'.encrypt($_rs["iKey"]).'"'.$sSelected.'>'.strOutput($_rs["sTitle"]).'</option>';

					}while($_rs=mysql_fetch_array($_oRS));
					$sColumn1 .= '</select>';
				}
				mysql_free_result($_oRS);

			break;
			default:return;
		}
		// Add help
		$sHelp = (isset($_aName["helpid"])) ? '<tr><td width="25" valign="top">'.getHelpVar($_aName["helpid"]).'</td>':'<tr><td width="25">&nbsp;</td>';

		$sColumn1 .= (isset($_aName["after"])) ? $_aName["after"] : '';
		$this->sRows .= $sHelp.'<td width="'.$this->iColumnWidth.'" valign="top"><label for="'.$sName.'">'.$sTitle.'</label></td><td>'.$_sIcon.$sColumn1.'</td><td valign="top">'.$sColumn2.'</td></tr>';
	}

/* ===============================================================================================================================
 Add the buttons
================================================================================================================================== */
	function addSubmit($_sDisabled=false){
		$sButtonSubmit = (!isset($this->sButtonSubmit))?xTranslate("Bewaar"):$this->sButtonSubmit;
		$sButtonReset = (!isset($this->sButtonReset))?xTranslate("Herstel"):$this->sButtonReset;
		$_sDisabled = ($_sDisabled) ? ' disabled="disabled"' : '';
		$this->sRows .= '<tr><td>&nbsp;</td><td>&nbsp;</td><td><button type="reset"'.$_sDisabled.'>'.$sButtonReset.'</button>&nbsp;<button type="submit"'.$_sDisabled.'>'.$sButtonSubmit.'</button></td><td>&nbsp;</td></tr>';
	}

/* ===============================================================================================================================
 Add a header to the form
================================================================================================================================== */
	function addHeader($sHeaderTitle){
		$this->sRows .= '<tr><td>&nbsp;</td><td colspan="3"><h2>'.$sHeaderTitle.'</h2></td></tr><tr><td colspan="4" style="height:6px;"></td></tr>';
	}

/* ===============================================================================================================================
 Add a subheader to the form
================================================================================================================================== */
	function addSubHeader($sHeaderTitle){
		$this->sRows .= '<tr><td>&nbsp;</td><td colspan="3"><h3 style="font-size:10px;">'.$sHeaderTitle.'</h3></td></tr>';
	}

/* ===============================================================================================================================
 Add a blank row to the form
================================================================================================================================== */
	function addRowBlank(){
		$this->sRows .= '<tr><td colspan="4">&nbsp;</td></tr>';
	}

/* ===============================================================================================================================
 Render the form before submit
================================================================================================================================== */
	function renderForm(){
		if($this->sTarget!="")$this->sTarget=' target="'.$this->sTarget.'"';
		if($this->sCSS!="")$this->sCSS=' style="'.$this->sCSS.'"';
		if($this->sClass!="")$this->sClass=' class="'.$this->sClass.'"';
		if($this->sEncType!="")$this->sEncType=' enctype="'.$this->sEncType.'"';

		$this->sReturn = '';

		// Include javascript md5
		if($this->bMd5){
			global $sLoc;
			$this->sReturn .= '<script type="text/javascript" src="'.$sLoc.'lib/md5.js"></script>';
		}
/*
var emailRegxp = /^([\w]+)(.[\w]+)*@([\w]+)(.[\w]{2,3}){1,2}$/;
var urlRegxp = /^(http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.){1}([\w]+)(.[\w]+){1,2}$/;

 if (emailRegxp.test(email) != true)alert('error');


*/
		$this->sReturn .= '<script type="text/javascript">
function submit'.$this->sID.'(){
	submitform = true;
	Ext.get("'.$this->sID.'").dom.action = "'.$this->sAction.'";
	'.$this->sValidation.'

	if(submitform==true){
		Ext.get("'.$this->sID.'").dom.submit();
	}else{
		alert(submitform);
	}
	return false;
}
</script>';


		$this->sReturn .= '<form onsubmit="return submit'.$this->sID.'()" name="'.$this->sName.'" id="'.$this->sID.'" method="'.$this->sMethod.'" '.$this->sTarget.$this->sCSS.$this->sClass.$this->sEncType.'>';
		if($this->iKeyUpdate!="")$this->sReturn .= '<input type="hidden" name="iKeyUpdate" value="'.encrypt($this->iKeyUpdate).'" />';
		$this->sReturn .= '<table border="0" cellspacing="2" cellpadding="0" '.$this->sExtra.'>';
		$this->sReturn .= $this->sRows;
		$this->sReturn .= '</table>';
		$this->sReturn .= '</form>';
		return $this->sReturn;
	}
/* ===============================================================================================================================
 Process the form after submit
================================================================================================================================== */
	function submitForm(){
		$_bSuccess=true;
		$aIgnore=array("iKeyUpdate");
		$aIgnorePart=array("_allowduplicate","_allownull");

		$_iKeyUpdate = (isset($_POST["iKeyUpdate"])) ? decrypt($_POST["iKeyUpdate"]) : 0;
		$_sUpdate = "";
		$_sInsert1 = "";
		$_sInsert2 = "";

		foreach (array_keys($_POST) as $p){
			$_bContinue=true;

			foreach($aIgnorePart as $_ignore){ if(strpos($p,$_ignore))$_bContinue=false; }

			if(!$_bContinue){
				// Extra validatie
/* ===============================================================================================================================
				Validate - Allow NULL
================================================================================================================================== */
				if(strpos($p,"_allownull")){
					if(trim($_POST[str_replace("_allownull","",$p)])==""){ $this->sError .= "\\n\\n - Er zijn n of meerdere verplichte velden niet ingevuld";$_bSuccess=false;break 1; }
				}
/* ===============================================================================================================================
				Validate - Allow Duplicate
================================================================================================================================== */
				if(strpos($p,"_allowduplicate")){
					if(getValue($this->sDbTable,"iKey",str_replace("_allowduplicate","",$p),$_iKeyUpdate)!=trim($_POST[str_replace("_allowduplicate","",$p)])){
					//echo "SELECT iKey FROM ".$this->sDbTable." WHERE ".str_replace("_allowduplicate","",$p)."='".trim($_POST[str_replace("_allowduplicate","",$p)])."' AND iKey<>".$_iKeyUpdate;
						$_sql_duplicate = (isset($_POST["iKeyUpdate"])) ? "SELECT iKey FROM ".$this->sDbTable." WHERE ".str_replace("_allowduplicate","",$p)."='".trim($_POST[str_replace("_allowduplicate","",$p)])."' AND iKey<>".$_iKeyUpdate : "SELECT iKey FROM ".$this->sDbTable." WHERE ".str_replace("_allowduplicate","",$p)."='".trim($_POST[str_replace("_allowduplicate","",$p)])."'"; 
						$oRS__=mysql_query($_sql_duplicate);
						if($rs__=mysql_fetch_array($oRS__)){
							$this->sError .= "\\n\\n - Er is een bestaande naam ingevuld voor een veld dat geen duplicaten mag bevatten";
							$_bSuccess=false; break 1;
						}
						mysql_free_result($oRS__);
					}
				}
			}

			if(!in_array($p,$aIgnore) && $_bContinue){		
				$_sValue = $_POST[$p];
				// Make integer when encrypted
				if(substr($p,0,1)=="i" && $_sValue!="" && ! is_numeric($_sValue))$_sValue = decrypt($_sValue);

				if(is_array($_POST[$p])){
					$_sValue = "";
					foreach($_POST[$p] as $aval){
						if($aval!="NULL")$_sValue .= $aval.",";
					}
					$_sValue = trim($_sValue,",");
				}

				// form
				$_sUpdate .= ($_sValue=="")? $p."=NULL,":$p."='".strInput($_sValue)."',";
				$_sInsert1 .= $p.",";
				$_sInsert2 .= ($_sValue=="") ? "NULL,":"'".strInput($_sValue)."',";
				// getvalue
				if($this->sSubmitType=="getvalue")Set_Value($p,$_sValue);
			}
		}

		$_sUpdate = trim($_sUpdate,",");
		$_sInsert1 = trim($_sInsert1,",");
		$_sInsert2 = trim($_sInsert2,",");

		if($_bSuccess==true){
			if($this->sSubmitType=="form"){
				if(isset($_POST["iKeyUpdate"])){
					// Update
					$_sql_ = "UPDATE ".$this->sDbTable." SET ".$_sUpdate." WHERE iKey=".$_iKeyUpdate;
					$_sql_check = "SELECT iKey FROM ".$this->sDbTable." WHERE iKey=".$_iKeyUpdate;
					if(getTableColumns($_sql_check)==false){
						$_sql_ = "INSERT INTO ".$this->sDbTable."(".$this->sUpdateKey.",".$_sInsert1.") VALUES(".$_iKeyUpdate.",".$_sInsert2.")";
					}
				}else{
					// Insert
					$_sql_ = "INSERT INTO ".$this->sDbTable."(".$_sInsert1.") VALUES(".$_sInsert2.")";
				}
				mysql_query($_sql_);
			}
			$func = $this->sOnSuccess;
			$func();
		}else{
			alert("Het formulier is niet verwerkt vanwege de volgende reden(en):".$this->sError);
		}
	
		die();
	}
}
?>