<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

date_default_timezone_set("Europe/Amsterdam");

if(isset($_SESSION[SESSION."user.sLang"])){
	switch(strtolower($_SESSION[SESSION."user.sLang"])){
		case "en":
			$sSetLocale="en_EN";
			$sDateFormatCal = "MM-d-yyyy";
			$sDateFormatUnix = "%m-%d-%Y";
			define("UNIXSTAMP_FULLDATE","%m-%d-%Y %H:%M");
			break;
		default:
			$sSetLocale=array("nld_nld", 'nl_NL');
			$sDateFormatCal = "d-MM-yyyy";
			$sDateFormatUnix = "%d-%m-%Y";
			define("UNIXSTAMP_FULLDATE","%d-%m-%Y %H:%M");
	}
}else{
	$sSetLocale=array("nld_nld", 'nl_NL');
}
$oldlocale = setlocale(LC_ALL, 0);
setlocale(LC_ALL, $sSetLocale);

$bLocInc = (isset($bLocInc)) ? $bLocInc : true;

if($bLocInc){
	$sLoc2=(isset($bInCMS))?$sLoc:$sLoc.$CMS_ROOT;
	if(isset($bBelowCMS) && $bBelowCMS)$sLoc2=$sLoc.$CMS_ROOT;
	if(isset($sLoc_inc))$sLoc2 = $sLoc_inc;
	include $sLoc2."lib/functions/log.php";
	include $sLoc2."lib/functions/db.php";
	include $sLoc2."lib/functions/strings.php";
	include $sLoc2."lib/functions/javascript.php";
	include $sLoc2."lib/functions/encryption.php";
	include $sLoc2."lib/functions/datetime.php";
	include $sLoc2."lib/functions/filesys.php";
	include $sLoc2."lib/functions/get.php";
	include $sLoc2."lib/functions/css.php";
	include $sLoc2."lib/functions/mail.php";
	include $sLoc2."lib/functions/form.php";
	include $sLoc2."lib/functions/rating.php";
	include $sLoc2."lib/functions/friendlyurls.php";
	include $sLoc2."lib/functions/GTranslate.php";
	if(isset($bInCMS) && $bInCMS==true)include $sLoc2."lib/includes/security.php";
	if(isset($bInCMS) && $bInCMS==true)include $sLoc2."lib/functions/xml.php";
	if(isset($bInCMS) && $bInCMS==true)include $sLoc2."lib/functions/parse.php";

	if(trim(Get_Value("config_bFriendlyUrls"))=="1"){
		define("USE_FRIENDLY_URL",true);
	}else{
		define("USE_FRIENDLY_URL",false);
	}
}
if(isset($bEditor) && $bEditor==true){
	include $sLoc2."lib/editor/fckeditor.php";
	$sBasePath = $sLoc2.'lib/editor/';
}
?>