<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once("payment.php");

class Creditcard extends Payment {
  private $_iDealFields = array();
	protected $_codes = array('100' => 'De transactie is door de credit-maatschappij goedgekeurd.',
                            '101' => 'De transactie is door de credit-maatschappij afgekeurd',
														'102' => 'De transactie is mislukt. Er is een fout opgetreden in de verwerking bij de
                                      creditmaatschappij',
														'203' => 'De transactie is geweigerd. Het creditcardnummer of het IP-adres zijn geblokkeerd');
														
  public function __construct($invoice = '', $totalprice = 0) {
  	if($invoice != '' && $totalprice > 0) {
	    $this->_url = 'https://payment.buckaroo.nl/sslplus/request_for_authorization.asp';  		
	    $this->_fields = array_merge($this->_fields, $this->_iDealFields);
		}
    parent::__construct($invoice, $totalprice);    
  }
  
	public function process($post) {
		parent::process($post);
		
		switch($this->_post['bpe_result']) {
			case "100":
				$this->updateStatus($this->_post['bpe_trx'], 0);
				$this->sendMail(true);
				$this->redirect();
				break;
			case "101":
      case "102":
      case "203":
				$this->updateStatus($this->_post['bpe_trx'], 1);
				$this->sendMail(false, false);
				$this->redirect();      
				break;
			case "802":
				$this->updateStatus($this->_post['bpe_trx'], 5);
        $this->showMessage();
        break;           
			case "804":
			case "810":
			case "811":
			case "812":
			case "813":
			case "814":
			case "815":
      default:
  			$this->updateStatus($this->_post['bpe_trx'], 1);
        $this->showMessage();
        break;
		}
	}
	
	public function redirect() {
		$filename = basename(__FILE__);
		global $sSiteLanguage;
		$sql = "SELECT iKeyStructure FROM tb_shop_payments WHERE sModule = '$filename' AND sLanguage = '$sSiteLanguage'";
		$result = mysql_query($sql) or die(mysql_error());
		$id = null;
		
		if($result) {
			$id = mysql_result($result, 0, 0);
			mysql_free_result($result);
			header("Location: http://".$_SERVER['HTTP_HOST']."/?id=".$id);
			die();
		}
		else {
			echo "Geen redirect pagina gevonden. Controleer instellingen voor de taal: $sSiteLanguage";
		}
	}

  protected function init() {
    parent::init();
    $this->_fields['BPE_Return_Success'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Error'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Reject'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
  }
  
  public function getForm() {
    if($this->_url != '') {
      $form = '<form action="'.$this->_url.'" method="post" name="payform">'."\r\n";
      $form .= $this->getFields();
      $form .= '</form>'."\r\n";
      return $form;
    }
    else
      throw new Exception("Url cannot be null or empty");
  }
}
?>