<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once("payment.php");

class IDeal extends Payment {
  private $_iDealFields = array('BPE_Timestamp' => '');
  private $_issuers = array('SNSBANK' => 'Sns bank',
                              'RABOBANK' => 'Rabobank',
                              'ABNAMRO' => 'Abn-Amro',
                              'FORTIS' => 'Fortis',
															'INGBANK' => 'ING Bank',
															'FRIESLAND' => 'Friesland Bank');
	protected $_codes = array('800' => 'Deze transactie is nog niet volledig verwerkt (pending)',
														'801' => 'Deze transactie is met succes voltooid.',
														'802' => 'Deze transactie is door klant geannuleerd',
														'803' => 'Deze transactie is niet binnen de maximale, toegestane tijd uitgevoerd',
														'804' => 'Deze transactie is om onbekende reden bij de bank mislukt',
														'810' => 'Issuer (bank) onbekend',
														'811' => 'Deze transactie is om technische redenen mislukt',
														'812' => 'De entrance-code is ongeldig',
														'813' => 'Aquirer-code is onbekend (intern)',
														'814' => 'Systeemfout. Status kan niet worden ge-update',
														'815' => 'Transactie niet gevonden');
														
  public function __construct($invoice = '', $totalprice = 0) {
  	if($invoice != '' && $totalprice > 0) {
	    $this->_url = 'https://payment.buckaroo.nl/gateway/ideal_payment.asp';  		
	    $this->_fields = array_merge($this->_fields, $this->_iDealFields);
		}
    parent::__construct($invoice, $totalprice);    
  }
  
	public function process($post) {
		parent::process($post);
		
		switch($this->_post['bpe_result']) {
			case "801":
				$this->updateStatus($this->_post['bpe_trx'], 0);
				$this->sendMail(true);
				$this->redirect();
				break;
			case "800":
				$this->updateStatus($this->_post['bpe_trx'], 1);
				$this->sendMail(false, false);
				$this->redirect();
				break;
			case "802":
				$this->updateStatus($this->_post['bpe_trx'], 5);   
        $this->showMessage();
        break;           
			case "803":
				$this->updateStatus($this->_post['bpe_trx'], 8);
        $this->showMessage();
        break;
			case "804":
			case "810":
			case "811":
			case "812":
			case "813":
			case "814":
			case "815":
  			$this->updateStatus($this->_post['bpe_trx'], 9);
        $this->showMessage();
        break;
		}
	}
	
	public function redirect() {
		$filename = basename(__FILE__);
		global $sSiteLanguage;
		$sql = "SELECT iKeyStructure FROM tb_shop_payments WHERE sModule = '$filename' AND sLanguage = '$sSiteLanguage'";
		$result = mysql_query($sql) or die(mysql_error());
		$id = null;
		
		if($result) {
			$id = mysql_result($result, 0, 0);
			mysql_free_result($result);
			header("Location: http://".$_SERVER['HTTP_HOST']."/?id=".$id);
			die();
		}
		else {
			echo "Geen redirect pagina gevonden. Controleer instellingen voor de taal: $sSiteLanguage";
		}
	}

  protected function init() {
    parent::init();
    $this->_fields['BPE_Return_Success'] = 'http://'.$_SERVER['HTTP_HOST'].'/'.'/?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Error'] = 'http://'.$_SERVER['HTTP_HOST'].'/'.'?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Reject'] = 'http://'.$_SERVER['HTTP_HOST'].'/'.'?id='.$_GET['id'].'&order=5';
  }
  
  public function getForm() {
    if($this->_url != '') {
      $form = '<form action="'.$this->_url.'" method="post" name="payform">'."\r\n";
      $form .= '<label for="issuers">'.translate(Selecteer_bank).'</label><select name="BPE_Issuer">'."\r\n";
      foreach($this->_issuers as $name => $value) {
        $form .= '<option value="'.$name.'">'.$value.'</option>'."\r\n";
      }
      $form .= '</select><br />'."\r\n";
      $form .= $this->getFields();      
      $form .= '</form>'."\r\n";
      return $form;
    }
    else
      throw new Exception("Url cannot be null or empty");
  }
}
?>