<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once("payment.php");

class Transfer extends Payment {
  private $_transferFields = array('BPE_Customername' => '',
																   'BPE_Customergender' => '',
																	 'BPE_Customermail' => '');
	protected $_codes = array('300' => 'Deze overschrijving is nog niet volledig verwerkt (pending)',
														'301' => 'Deze overschrijving is met succes voltooid.',
														'302' => 'Deze overschrijving is afgewezen',
														'303' => 'Deze overschrijving is niet binnen de gestelde termijn ontvangen.',
														'305' => 'De overschrijving is gematched, maar er is te weinig geld overgemaakt',
														'306' => 'De overschrijving is gematched, maar er is te veel geld overgemaakt',
														'309' => 'De overschrijving is geannuleerd voordat het geld is overgemaakt');
														
  public function __construct($invoice = '', $totalprice = 0) {
  	if($invoice != '' && $totalprice > 0) {
	    $this->_url = 'https://payment.buckaroo.nl/gateway/transfer.asp';	
	    $this->_fields = array_merge($this->_fields, $this->_transferFields);
		}
    parent::__construct($invoice, $totalprice);    
  }
  
	public function process($post, $showMessage = true) {
		parent::process($post);
		switch($this->_post['bpe_result']) {
			case "301":
				$this->updateStatus($this->_post['bpe_trx'], 0);
				$this->sendMail(true);
				break;
			case "300":
				$this->updateStatus($this->_post['bpe_trx'], 1);
				$this->sendMail(false, false);
        if($showMessage)
  				$this->redirect();
				break;
			case "302":
				$this->updateStatus($this->_post['bpe_trx'], 10);
        if($showMessage)
          $this->showMessage();
        break;
			case "303":
				$this->updateStatus($this->_post['bpe_trx'], 8);
        if($showMessage)
          $this->showMessage();
        break;
			case "304":
				$this->updateStatus($this->_post['bpe_trx'], 6);
        if($showMessage)
          $this->showMessage();
        break;
			case "306":
				$this->updateStatus($this->_post['bpe_trx'], 7);
        if($showMessage)
          $this->showMessage();
        break;
			case "309":
				$this->updateStatus($this->_post['bpe_trx'], 5);
        if($showMessage)
          $this->showMessage();
				break;
		}
	}
	
	public function redirect() {
		$filename = basename(__FILE__);
		global $sSiteLanguage;
		$sql = "SELECT iKeyStructure FROM tb_shop_payments WHERE sModule = '$filename' AND sLanguage = '$sSiteLanguage'";
		$result = mysql_query($sql) or die(mysql_error());
		$id = null;
		
		if($result) {
			$id = mysql_result($result, 0, 0);
			mysql_free_result($result);
			header("Location: http://".$_SERVER['HTTP_HOST']."/?id=".$id);
			die();
		}
		else {
			echo "Geen redirect pagina gevonden. Controleer instellingen voor de taal: $sSiteLanguage";
		}
	}

  protected function init() {
    parent::init();
	  $this->_fields['BPE_Customername'] = $_SESSION[SESSION."shoporder1"]["sFirstname"].' '.$_SESSION[SESSION."shoporder1"]['sLastname'];
		$this->_fields['BPE_Customermail'] = $_SESSION[SESSION."shoporder1"]['sMail'];
    $this->_fields['BPE_Return_Success'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Error'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
    $this->_fields['BPE_Return_Reject'] = 'http://'.$_SERVER['HTTP_HOST'].'?id='.$_GET['id'].'&order=5';
  }
  
  public function getForm() {
    if($this->_url != '') {
      $form = '<form action="'.$this->_url.'" method="post" name="payform">'."\r\n";
      $form .= $this->getFields();      
      $form .= '</form>'."\r\n";
      return $form;
    }
    else
      throw new Exception("Url cannot be null or empty");
  }
}
?>