<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
 
include_once("payment.php");

class IDeal extends Payment {
  protected $_merchantKey = '';
  protected $_fields = array('key' => '',
                           'merchantID' => '',
                           'subID' => '',
                           'amount' => '',                           
                           'purchaseID' => '',
                           'language' => '',
                           'currency' => '',
                           'description' => 'description',
                           'hash' => '',
                           'paymentType' => 'ideal',
                           'validUntil' => '',
                           'urlSuccess' => '',
                           'urlCancel' => '',
                           'urlError' => '',
                           'itemNumber1' => '1',
                           'itemDescription1' => 'description',
                           'itemQuantity1' => '1');

  public function __construct($invoice = '', $totalprice = 0) {
  	//if($invoice != '' && $totalprice > 0) {
	    	$this->_url = 'https://ideal.secure-ing.com/ideal/mpiPayInitIng.do';
        	//$this->_url = 'https://ideal.rabobank.nl/ideal/mpiPayInitRabo.do';
		//}
    parent::__construct($invoice, $totalprice);    
  }
  
  protected function init() {
  	$sql = "SELECT iTotal, iSendCosts FROM tb_shop_orders  WHERE iKey=".$this->getKey($this->_invoice);
	$price = getTableColumns($sql);
	$totalprice = $price['iTotal'] + $price['iSendCosts'] + $_SESSION[SESSION."shoporder1"]["sPaymentCosts"];

    global $sSiteLanguage;
    $this->_fields['key'] = $this->_secretKey; //'sh4A45cBHDeXtVte'; 
    $this->_fields['merchantID'] = $this->_merchantKey; 
    $this->_fields['subID'] = 0;
    $this->_fields['amount'] = $totalprice*100;//str_replace(",", ".", $this->_totalprice)*100;//(int)number_format($this->_totalprice, 2, "", "");
    $this->_fields['purchaseID'] = $this->_invoice;
    $this->_fields['language'] = $sSiteLanguage;
    $this->_fields['currency'] = 'EUR';
    $this->_fields['validUntil'] = date('Y-m-d\TH:i:s.000\Z', time()+900);
    $hash = encrypt("status=success&p=".$this->_invoice);
    $this->_fields['urlSuccess'] = 'http://'.$_SERVER['HTTP_HOST'].'/?id='.$_GET['id'].'&order=5&&h='.urlencode($hash);//order=5&status=success&p='.$this->_invoice;
    $hash = encrypt("status=cancelled&p=".$this->_invoice);
    $this->_fields['urlCancel'] = 'http://'.$_SERVER['HTTP_HOST'].'/?id='.$_GET['id'].'&order=5&&h='.urlencode($hash);
    $hash = encrypt("status=error&p=".$this->_invoice);    
    $this->_fields['urlError'] = 'http://'.$_SERVER['HTTP_HOST'].'/?id='.$_GET['id'].'&order=5&&h='.urlencode($hash);
    $this->_fields['itemPrice1'] = $totalprice*100;//(int)number_format($this->_totalprice, 2, "", "");    
    $this->_fields['hash'] = $this->createHash();
  }
  
  public function updateStatus($purchaseId, $status) {
    $id = $this->getKey($purchaseId);
    $sql = "UPDATE `tb_shop_orders` SET `iKeyStatus` = $status WHERE `iKey` = $id";
    mysql_query($sql) or die(mysql_error()."<br />".$sql);
  }

  private function createHash() {
    $string = $this->_fields['key'].$this->_fields['merchantID'].$this->_fields['subID'].$this->_fields['amount']
              .$this->_fields['purchaseID'].$this->_fields['paymentType'].$this->_fields['validUntil'].$this->_fields['itemNumber1']
              .$this->_fields['itemDescription1'].$this->_fields['itemQuantity1'].$this->_fields['itemPrice1'];

    $string = preg_replace(array("/[ \t\n]/", '/&amp;/i', '/&lt;/i', '/&gt;/i', '/&quot/i'),
                           array( '', '&', '<', '>', '"'),
                           $string);

    return sha1($string);
  } 
  
  public function getForm() {
    if($this->_url != '') {
      $form = '<form action="'.$this->_url.'" method="post" name="payform">'."\r\n";
      $form .= $this->getFields();
      $form .= '<br />
                <br />
                <input type="submit" value="'.translate("Afrekenen").'" />
                <input type="button" onclick="window.print()" value="Print" />
                <br />';      
      $form .= '</form>'."\r\n";
      return $form;
    }
    else
      throw new Exception("Url cannot be null or empty");
  }

  public function redirect() {
		$filename = basename(__FILE__);
		global $sSiteLanguage;
		$sql = "SELECT iKeyStructure FROM tb_shop_payments WHERE sModule = '$filename' AND sLanguage = '$sSiteLanguage'";
		$result = mysql_query($sql) or die(mysql_error());
		$id = null;
		
		if($result) {
			$id = mysql_result($result, 0, 0);
			mysql_free_result($result);
			header("Location: http://".$_SERVER['HTTP_HOST']."/?id=".$id);
			die();
		}
		else {
			echo "Geen redirect pagina gevonden. Controleer instellingen voor de taal: $sSiteLanguage";
		}    
  }
}
?>