<?php
/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function getHost($url){
	$parsed = parse_url($url);
	$hostname = (isset($parsed['host'])) ? trim(str_replace("www.","",$parsed['host']),"/") : trim(str_replace("www.","",$url),"/");
	return $hostname;
}
function link2absolute($url,$link){
	$root = url2dir($url);
	if(substr($link,0,1)=="/"){
		$parsed = parse_url($url);
		//$link = (strrpos($link,"/")) ? substr($link,strrpos($link,"/"),strlen($link)-strrpos($link,"/")) : $link;
		$sDir = (isset($parsed['host'])) ? $parsed['scheme']."://".$parsed['host']."/" : trim($url);
	}else{
		$iDirUp = substr_count($link,"../");
		$link = str_replace("../","",$link);
		$iDirUp += substr_count($link,"/");
		$link = trim($link,"/");
		$sDir = dirUp($root, $iDirUp);
	}
	return $sDir.ltrim($link,"/");
}
function dirUp($url,$iDirUp){
	$sEvalStart = "";
	$sEvalEnd = "";
	for($i=0;$i<$iDirUp;$i++){
		$sEvalStart .= "dirname(";
		$sEvalEnd .= ")";
	}
	$sEval = "\$url = ".$sEvalStart.'"'.$url.'"'.$sEvalEnd.";";
	eval($sEval);
	return $url;
}
function checkHost($url){
	$domain = "http://".getHost($url);
	$sql = "SELECT iKey FROM spider_domains WHERE sDomain='".addslashes($domain)."'";
	$aCheck = getSqlRecord($sql);

	if(!$aCheck){
		// With or without www.
		$bWWW = false;
		$iResponse = getResponse($domain);

		if($iResponse == 200 || $iResponse == 302||$iResponse == 304){
			$iResponse = getResponse(str_replace("http://","http://www.",$domain));
			if($iResponse != 200 && $iResponse != 302 && $iResponse != 304){
				$domain = str_replace("http://","http://www.",$domain);
			}
		}
		if($iResponse != 200 && $iResponse != 302 && $iResponse != 304 && urlExists($domain."/robots.txt")){
			$sRobotsTxt = getPage($domain."/robots.txt");
		}else{
			$sRobotsTxt = "";
		}

		$sql = "INSERT INTO spider_domains(sDomain,sResponseCode,iPageCount,dLastSpider,dCreated,sRobotsTxt) VALUES('".addslashes($domain)."','".$iResponse."',0,'".date("Y-m-d H:i:s")."','".date("Y-m-d H:i:s")."','".addslashes($sRobotsTxt)."')";
		mysql_query($sql);

		toLog('Host added '.$url);
	}
}

function url2dir($url){
	$path_parts = pathinfo($url);
	if(isset($path_parts['dirname']) && $path_parts['dirname']!="http:"){
		$sReturn = "";
		$sReturn .= (isset($path_parts['dirname'])) ? $path_parts['dirname']."/" : '';
		$sReturn .= (isset($path_parts['basename'])) ? $path_parts['basename'] : '';
		$sReturn = (isset($path_parts['extension'])) ? str_replace(".".$path_parts['extension'],"",str_replace($path_parts['filename'],"",$sReturn)) : $sReturn;
	}else{
		$sReturn = $url;
	}
	return trim($sReturn,"/")."/";
}
function removeWww($url){
	return $url;
	/*
	$aQs = explode("?",$url);
	$parsed = parse_url($aQs[0]);
	$sReturn = "";
	$_i = 0;
	foreach($parsed as $dir){
		if(trim($dir)!="" && $dir!="/"){
			if($_i==0){
				$sReturn .= $dir."://";
			}elseif($_i==1){
				$sReturn .= str_replace("www.","",$dir);
			}else{
				$sReturn .= $dir;
			}
		}
		$_i++;
	}
	$sReturn = trim($sReturn);
	$sReturn .= (isset($aQs[1]) && $aQs[1]!="") ? "?".$aQs[1] : '';
	return $sReturn;
	*/
}

function getResponse($url){
	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $url);
	curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 20);
	curl_setopt ($ch, CURLOPT_USERAGENT, USER_AGENT);
	// Only calling the head
	curl_setopt($ch, CURLOPT_HEADER, true); // header will be at output
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'HEAD'); // HTTP request is 'HEAD'
	curl_exec($ch);
	$response = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	curl_close ($ch);

	return $response;
}
function urlExists($url){
	$iResponse2 = getResponse($url);
	if($iResponse != 200 && $iResponse != 302 && $iResponse != 304 && $iResponse != 0){
		return false;
	}else{
		return true;
	}
}
function getPage($url){
	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $url);
	curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 20);
	curl_setopt ($ch, CURLOPT_USERAGENT, USER_AGENT);
	$content = curl_exec ($ch);
	curl_close ($ch);

	return $content;
}

function toLog($log){
	if(OUTPUT_LOG){
		echo date("Y-m-d H:i:s").' '.$log.'';
	}
}
/* SQL record to array */
function getSqlRecord($sSQL_){
	$result = mysql_query($sSQL_)
	 or die(mysql_error()." - ".$sSQL_);
	$i_=0;
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		foreach ($line as $col_name => $col_value){
			$aValue_[$col_name]=$col_value;
		}
	}
	mysql_free_result($result);

	return (isset($aValue_) && is_array($aValue_)) ? $aValue_ : false;
}

/* Multiple SQL records to array */
function getSqlRecords($sSQL_){	
	$result = mysql_query($sSQL_)
	 or die(mysql_error()." - ".$sSQL_);
	$i_=0;
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		do{
			foreach ($line as $col_name => $col_value){
				$aValue_[$i_][$col_name]=$col_value;
			}
			$i_++;
		}while($line=mysql_fetch_array($result));
	}
	mysql_free_result($result);

	return (isset($aValue_)) ? $aValue_ : false;
}
function getNextKeySpider($sTable,$sColumn,$sWhere){
	$sql="select max(".$sColumn.") as maxval from ".$sTable.$sWhere."";
	$oFunc=mysql_query($sql);
	if($rs_f=mysql_fetch_array($oFunc)){
		$iMax = ($rs_f["maxval"]=="") ? 1 : $rs_f["maxval"]+1;
		return $iMax;
	}else{
		return false;
	}
}

?>