/**
 *	Nensor Content Management
 *  Copyright (C) 2009 Sem Kokhuis, www.nensor.com
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *	This source file is subject to the General Public License (GPL)
 * 	that is bundled with this package in the file LICENSE.txt.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

$(document).ready(function(){
	if($.cookie('adminbar_toolbar') != "off"){
		// Add images to editable content
		var oImg = jQuery(document.createElement("img"));
		oImg.attr("class","cms-edit-btn");
		oImg.attr("src", "/" + cms_root + "lib/images/inline/edit.gif");
		oImg.attr("unselectable","on");
		$('.c-inline-content').prepend(oImg);
		// Module
		var oImg = jQuery(document.createElement("img"));
		oImg.attr("class","cms-edit-mod-btn");
		oImg.attr("src", "/" + cms_root + "lib/images/inline/mod.gif");
		oImg.attr("unselectable","on");
		$('.c-inline-module').prepend(oImg);
	}

	// Edit box
	if($.cookie('adminbar_left')!=null && $.cookie('adminbar_top')!=null){
		iTop = (parseInt($.cookie('adminbar_top')) < -45) ? -45: $.cookie('adminbar_top');
		iLeft = (parseInt($.cookie('adminbar_left')) < -335) ? -335: $.cookie('adminbar_left');
		$("#cms-drag-box").css("left",iLeft);
		$("#cms-drag-box").css("top",iTop);
	}
	$("#cms-drag-box").css("display","block");

	$("#cms-drag-box").easydrag();
	//$("#cms-drag-box").setHandler('.cms-edit-handler');
	$("#cms-drag-box").ondrop(function(e, element){
		if($(element).css("top")<=-45)$(element).css("top")=45;
		$.cookie('adminbar_top', $(element).css("top"), { path: '/',expires: 30});
		$.cookie('adminbar_left', $(element).css("left"), { path: '/',expires: 30});
	});

	var myNicEditor = new nicEditor({uploadURI : "/" + cms_root + 'nensor.adminbar.php','buttonList':['bold','italic','underline','left','center','right','justify','ol','ul','strikethrough','indent','outdent','hr','image','upload','forecolor','link','unlink','fontFormat','xhtml']});
	myNicEditor.setPanel('cms-box-edit');

	$('#cms-save-page').click(function() {
		$('#cms-bar-msg').html('<b style="color:#ff0000">...</b>');
		$('#cms-bar-msg').fadeIn(200);
		var $element = $('.c-inline-content');
			var sPost = '';
			for(var i = 0, n = $element.length;  i < n;  ++i ) {
				var element = $element[i];
				$('#'+element.id+' .cms-edit-btn').remove();
				sPost += element.id +'[@@][CMS][__]'+document.getElementById(element.id).innerHTML+'[__][CMS][@@]';
			}
	
		$.post("/" + cms_root + "nensor.adminbar.php", { page: sPost },
				function(data){
					$('#cms-bar-msg').html('<b style="color:#ff0000">'+cms_saved+'</b>');
					$('#cms-bar-msg').fadeIn(200);
				});
	});

	$('#cms-min-toolbar').click(function() { 
		if($.cookie('adminbar_toolbar')=="" || $.cookie('adminbar_toolbar')==null || $.cookie('adminbar_toolbar') == "on"){
			$.cookie('adminbar_toolbar', "off", { path: '/',expires: 30});
		}else{
			$.cookie('adminbar_toolbar', "on", { path: '/',expires: 30});
		}
		document.location.reload();
	});


	$('#cms-refresh-page').click(function() { document.location.reload();});
	$('#cms-template-page').click(function() { document.location="/" + cms_root+'modules/templates/inline/?t='+cms_t+'&hash='+cms_hash+'&id='+cms_id;});

	$('#cms-template-page').mouseover(function() {
		$('#cms-bar-msg').html(cms_template);
		$('#cms-bar-msg').fadeIn(200);
	});
	$('#cms-template-page').mouseout(function() {
		$('#cms-bar-msg').fadeOut(200);
	});
	$('#cms-min-toolbar').mouseover(function() {
		$('#cms-bar-msg').html(cms_min);
		$('#cms-bar-msg').fadeIn(200);
	});
	$('#cms-min-toolbar').mouseout(function() {
		$('#cms-bar-msg').fadeOut(200);
	});
	$('#cms-refresh-page').mouseover(function() {
		$('#cms-bar-msg').html(cms_refresh);
		$('#cms-bar-msg').fadeIn(200);
	});
	$('#cms-refresh-page').mouseout(function() {
		$('#cms-bar-msg').fadeOut(200);
	});
	$('#cms-save-page').mouseover(function() {
		$('#cms-bar-msg').html(cms_save);
		$('#cms-bar-msg').fadeIn(200);
	});
	$('#cms-save-page').mouseout(function() {
		$('#cms-bar-msg').fadeOut(200);
	});
	$('#cms-help').mouseover(function() {
		$('#cms-bar-msg').html(cms_help);
		$('#cms-bar-msg').fadeIn(200);
	});
	$('#cms-help').mouseout(function() {
		$('#cms-bar-msg').fadeOut(200);
	});

	if($.cookie('adminbar_toolbar') != "off"){
		$('.c-inline-module').click(function() {
			window.open($("#"+this.id).attr("clickhandler"), "module", "width=800,height=600,resizable=true,toolbar=false,locationbar=false,directories=false,status=false,menubar=false,scrollbars=true,copyhistory=false");
	
		});
		$('.c-inline-content').click(function() {
			$('#'+this.id+' .cms-edit-btn').remove();
			myNicEditor.removeInstance(this.id);
			myNicEditor.addInstance(this.id);
		});
	}
});